diff --git a/build.gradle.kts b/build.gradle.kts
index 333ceca85..9b61f98b1 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -1,122 +1,9 @@
-import com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar
-import com.github.jengelman.gradle.plugins.shadow.transformers.Log4j2PluginsCacheFileTransformer
-import java.text.SimpleDateFormat
-import java.util.*
+group = providers.gradleProperty("bta.group").get()
+version = providers.gradleProperty("bta.version").get()
 
-plugins {
-    id("java")
-    id("com.github.johnrengelman.shadow").version("8.1.0")
-    id("maven-publish")
-}
-
-group = "net.minecraft"
-version = "7.3"
-val texturePackVersion = 3;
-val buildChannel = "DEVELOPMENT"
-
-run {
-    val file = File("version.txt")
-    if (file.exists()) {
-        val ver = file.readText().trim()
-        version = ver
-    }
-}
-
-val serverInclude: Configuration by configurations.creating
-val clientInclude: Configuration by configurations.creating
-
-sourceSets {
-    create("common")
-    create("template")
-}
-
-task("generateJava", Copy::class) {
-    group = "bta"
-    delete("src/main/java/net/minecraft/core/Version.java")
-    from("src/template/java")
-    into("src/main/java")
-    include("**/*.java")
-    expand(mapOf("version" to version, "buildTime" to SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(Date()), "buildChannel" to buildChannel, "packVersion" to texturePackVersion))
-}
-
-task("runRecipeGenerator", JavaExec::class) {
-    group = "bta"
-    mainClass.set("net.minecraft.datagen.RecipesGenerator")
-    classpath = sourceSets["main"].runtimeClasspath
-
-    args = listOf("--output", File(buildDir, "resources/common/recipes").toString())
-}
-
-tasks.withType(JavaCompile::class.java) {
-    dependsOn(tasks["generateJava"])
-    options.isIncremental = false
-    options.encoding = "UTF-8"
-    if (JavaVersion.current() != JavaVersion.VERSION_1_8) {
-        options.compilerArgs.add("--release")
-        options.compilerArgs.add("8")
-    }
-}
-
-task("jarClient", ShadowJar::class) {
-    group = "bta"
-    configurations = listOf(clientInclude)
-    dependsOn(tasks["generateJava"], tasks["runRecipeGenerator"])
-
-    from(sourceSets["main"].output.classesDirs)
-    from(sourceSets["main"].resources)
-    exclude("fabric.mod.json")
-
-    archiveFileName.set("bta-client.jar")
-    manifest {
-        attributes["Main-Class"] = "net.minecraft.client.Minecraft"
-        attributes["Implementation-Version"] = version
-    }
-}
-
-task("jarServer", ShadowJar::class) {
-    group = "bta"
-    configurations = listOf(serverInclude)
-    dependsOn(tasks["generateJava"], tasks["runRecipeGenerator"])
-
-    from(sourceSets["main"].output.classesDirs)
-    exclude("fabric.mod.json")
-
-    archiveFileName.set("bta-server.jar")
-    transform(Log4j2PluginsCacheFileTransformer::class.java)
-    manifest {
-        attributes["Main-Class"] = "net.minecraft.server.MinecraftServer"
-        attributes["Implementation-Version"] = version
-    }
-}
-
-repositories {
-    mavenCentral()
-    maven("https://libraries.minecraft.net/")
-    maven("https://jitpack.io")
-    ivy {
-        url = uri("https://piston-data.mojang.com")
-        patternLayout {
-            artifact("v1/[organisation]/[revision]/[module].jar")
-            m2Compatible
-        }
-        metadataSources { artifact() }
-    }
-    ivy {
-        url = uri("https://github.com/Turnip-Labs")
-        patternLayout {
-            artifact("[organisation]/releases/download/[revision]/[module]-bta-[revision].jar")
-            m2Compatible
-        }
-        metadataSources { artifact() }
-    }
-    jcenter()
-}
-
-val lwjglVersion = "3.3.4"
-
-val lwjglNatives = Pair(
-    System.getProperty("os.name")!!,
-    System.getProperty("os.arch")!!
+ext["lwjglNatives"] = Pair(
+        System.getProperty("os.name")!!,
+        System.getProperty("os.arch")!!
 ).let { (name, arch) ->
     when {
         arrayOf("Linux", "SunOS", "Unit").any { name.startsWith(it) } ->
@@ -139,111 +26,3 @@ val lwjglNatives = Pair(
             throw Error("Unrecognized or unsupported platform. Please set \"lwjglNatives\" manually")
     }
 }
-dependencies {
-    implementation("org.jetbrains:annotations:24.0.0")?.let { clientInclude(it); serverInclude(it) }
-    implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.1")?.let { clientInclude(it) }
-    implementation(platform("org.lwjgl:lwjgl-bom:$lwjglVersion"))
-
-    implementation("org.lwjgl", "lwjgl")
-    implementation("org.lwjgl", "lwjgl-assimp")
-    implementation("org.lwjgl", "lwjgl-glfw")
-    implementation("org.lwjgl", "lwjgl-openal")
-    implementation("org.lwjgl", "lwjgl-opengl")
-    implementation("org.lwjgl", "lwjgl-stb")
-    runtimeOnly("org.lwjgl", "lwjgl", classifier = lwjglNatives)
-    runtimeOnly("org.lwjgl", "lwjgl-assimp", classifier = lwjglNatives)
-    runtimeOnly("org.lwjgl", "lwjgl-glfw", classifier = lwjglNatives)
-    runtimeOnly("org.lwjgl", "lwjgl-openal", classifier = lwjglNatives)
-    runtimeOnly("org.lwjgl", "lwjgl-opengl", classifier = lwjglNatives)
-    runtimeOnly("org.lwjgl", "lwjgl-stb", classifier = lwjglNatives)
-    implementation("com.google.code.gson:gson:2.10.1")?.let { clientInclude(it); serverInclude(it) }
-
-    implementation("com.github.JnCrMx:discord-game-sdk4j:v0.5.5")?.let { clientInclude(it) }
-
-    implementation("objects:client:43db9b498cb67058d2e12d394e6507722e71bb45") // Minecraft client jar
-    implementation("com.mojang:brigadier:1.0.18")?.let { clientInclude(it); serverInclude(it) }
-
-    implementation("com.formdev:flatlaf:3.1.1")?.let { clientInclude(it) } // Dark theme used by SeedViewer
-    
-    implementation("org.slf4j:slf4j-api:2.0.7")?.let { clientInclude(it); serverInclude(it) }
-
-    val log4jVersion = "2.19.0"
-    implementation("org.apache.logging.log4j:log4j-core:${log4jVersion}")?.let { clientInclude(it); serverInclude(it) }
-    implementation("org.apache.logging.log4j:log4j-api:${log4jVersion}")?.let { clientInclude(it); serverInclude(it) }
-    implementation("org.apache.logging.log4j:log4j-slf4j2-impl:${log4jVersion}")?.let { clientInclude(it); serverInclude(it) }
-
-    runtimeOnly(sourceSets.getByName("common").output)?.let { clientInclude(it); serverInclude(it) }
-}
-
-task("copyNatives", Copy::class) {
-    configurations.runtimeClasspath.get()
-        .filter { it.extension == "jar" && it.name.contains("platform") }
-        .forEach { from(zipTree(it).filter { file -> !file.name.contains("META-INF") && !file.name.contains(".MF") }).into("$buildDir/natives") }
-}
-
-task("runServer", JavaExec::class) {
-    dependsOn(tasks["runRecipeGenerator"])
-    val mpDir = File(workingDir, "mp")
-    mpDir.mkdir()
-    workingDir = mpDir
-    group = "bta"
-    mainClass.set("net.minecraft.server.MinecraftServer")
-    classpath = sourceSets["main"].runtimeClasspath
-    jvmArgs = listOf("-ea")
-}
-
-task("runClient", JavaExec::class) {
-    dependsOn(tasks["copyNatives"], tasks["runRecipeGenerator"])
-    group = "bta"
-    mainClass.set("net.minecraft.client.Minecraft")
-    classpath = sourceSets["main"].runtimeClasspath
-    if (arrayOf("Mac OS X", "Darwin").any { System.getProperty("os.name").startsWith(it) }) {
-        jvmArgs = listOf("-XstartOnFirstThread", "-Djava.awt.headless=true", "-ea")
-    } else {
-        jvmArgs = listOf("-ea")
-    }
-
-    systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
-}
-
-task("runColorizerGenerator", JavaExec::class) {
-    dependsOn(tasks["copyNatives"])
-    group = "bta"
-    mainClass.set("net.betterthanadventure.utils.ColorizerGenerator")
-    classpath = sourceSets["main"].runtimeClasspath
-
-    systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
-}
-
-val createManifestFileTask = tasks.register("createManifestFileTask") {
-    group = "bta"
-    outputs.dir(temporaryDir)
-
-    doLast {
-        val resource = File(temporaryDir, "manifest.json")
-        resource.writeText(
-            "{\n" +
-                "    \"description\": {\n" +
-                "        \"name\": \"Default\",\n" +
-                "        \"line1\": \"The default look of Minecraft.\",\n" +
-                "        \"line2\": \"\",\n" +
-                "        \"packVersion\": \"$version\",\n" +
-                "        \"format\": $texturePackVersion\n" +
-                "    }\n" +
-                "}")
-    }
-}
-
-sourceSets {
-    main {
-        resources {
-            srcDir(createManifestFileTask.map { it.temporaryDir })
-        }
-    }
-}
-
-java {
-    sourceCompatibility = JavaVersion.VERSION_1_8
-    targetCompatibility = JavaVersion.VERSION_1_8
-}
-
diff --git a/game/client/.gitignore b/game/client/.gitignore
new file mode 100644
index 000000000..2959db291
--- /dev/null
+++ b/game/client/.gitignore
@@ -0,0 +1,2 @@
+build
+logs
\ No newline at end of file
diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
new file mode 100644
index 000000000..b850ec707
--- /dev/null
+++ b/game/client/build.gradle.kts
@@ -0,0 +1,134 @@
+import com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar
+
+plugins {
+    id("java")
+    alias(libs.plugins.shadow)
+}
+
+group = providers.gradleProperty("bta.group").get()
+version = providers.gradleProperty("bta.version").get()
+val texturePackFormat = providers.gradleProperty("bta.texturePackFormat").get()
+
+val include: Configuration by configurations.creating
+
+repositories {
+    mavenCentral()
+    maven("https://libraries.minecraft.net/")
+    maven("https://jitpack.io")
+    ivy {
+        url = uri("https://piston-data.mojang.com")
+        patternLayout {
+            artifact("v1/[organisation]/[revision]/[module].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
+    ivy {
+        url = uri("https://github.com/Turnip-Labs")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/[module]-bta-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
+}
+
+dependencies {
+    implementation(project(":game:core"))?.let { include(it) }
+    runtimeOnly(project(path = ":util:datagen", configuration = "output"))?.let { include(it) }
+
+    // <core dependencies>
+    implementation(libs.jetbrains.annotations)?.let { include(it) }
+    implementation(libs.gson)?.let { include(it) }
+    implementation(libs.brigadier)?.let { include(it) }
+    implementation(libs.bundles.log4j)?.let { include(it) }
+    // </core dependencies>
+
+    implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.1")?.let { include(it) }
+
+    implementation(libs.bundles.lwjgl)
+    for (lib in libs.bundles.lwjgl.get()) {
+        runtimeOnly(lib.group, lib.name, classifier = rootProject.ext["lwjglNatives"].toString())
+    }
+    implementation(platform(libs.lwjgl.bom))
+
+    implementation("com.github.JnCrMx:discord-game-sdk4j:v0.5.5")?.let { include(it) }
+
+    implementation("objects:client:43db9b498cb67058d2e12d394e6507722e71bb45") // Minecraft client jar
+
+    implementation("com.formdev:flatlaf:3.1.1")?.let { include(it) } // Dark theme used by SeedViewer
+}
+
+java {
+    sourceCompatibility = JavaVersion.VERSION_1_8
+    targetCompatibility = JavaVersion.VERSION_1_8
+}
+
+//region Tasks
+val manifestGenerator by tasks.registering {
+    group = "bta.generator"
+    outputs.dir(temporaryDir)
+
+    doLast {
+        val outputFile = File(temporaryDir, "manifest.json")
+        outputFile.writeText(
+                """
+                    {
+                        "description": {
+                            "name": "Default",
+                            "line1": "The default look of Minecraft.",
+                            "line2": "",
+                            "packVersion": "$version",
+                            "format": $texturePackFormat
+                        }
+                    }
+                """.trimIndent()
+        )
+    }
+}
+
+val run by tasks.registering(JavaExec::class) {
+    group = "bta"
+
+    mainClass.set("net.minecraft.client.Minecraft")
+    classpath += sourceSets["main"].runtimeClasspath
+    jvmArgs = if (arrayOf("Mac OS X", "Darwin").any { System.getProperty("os.name").startsWith(it) }) {
+        listOf("-XstartOnFirstThread", "-Djava.awt.headless=true", "-ea")
+    } else {
+        listOf("-ea")
+    }
+
+    systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
+}
+
+val buildJar by tasks.registering(ShadowJar::class) {
+    group = "bta"
+    configurations = listOf(include)
+
+    from(sourceSets.main.get().output.classesDirs)
+    from(sourceSets.main.get().resources)
+    exclude("fabric.mod.json")
+
+    archiveFileName = "bta-client.jar"
+    manifest {
+        attributes["Main-Class"] = "net.minecraft.client.Minecraft"
+        attributes["Implementation-Version"] = version
+    }
+}
+
+tasks.withType(JavaCompile::class.java) {
+    options.isIncremental = false
+    options.encoding = "UTF-8"
+    if (JavaVersion.current() != JavaVersion.VERSION_1_8) {
+        options.compilerArgs.add("--release")
+        options.compilerArgs.add("8")
+    }
+}
+//endregion
+
+sourceSets.main {
+    resources {
+        srcDir(manifestGenerator)
+    }
+}
+
diff --git a/src/main/java/net/betterthanadventure/utils/DataDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
similarity index 96%
rename from src/main/java/net/betterthanadventure/utils/DataDumper.java
rename to game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
index 6e62d8e54..2b9d5de72 100644
--- a/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -75,8 +75,8 @@ public class DataDumper implements MinecraftAccessor {
 
         writer = new BufferedWriter(new FileWriter(new File(wikiDumpFile, "blocks.csv")));
         writer.write("ID,Translation Key,Hardness,Blast Resistance,Mining Level,Stacksize,Name,Description,Tags\n");
-        for (int i = 0; i < Block.blocksList.length; i++) {
-            Block block = Block.blocksList[i];
+        for (int i = 0; i < Blocks.blocksList.length; i++) {
+            Block block = Blocks.blocksList[i];
             String string = blockToCSV(block);
             if (string.isEmpty() && !hideUnused){
                 string = i + "\n";
@@ -87,7 +87,7 @@ public class DataDumper implements MinecraftAccessor {
 
         writer = new BufferedWriter(new FileWriter(new File(wikiDumpFile, "items.csv")));
         writer.write("ID,Translation Key,Durability,Restores,Stacksize,Name,Description,Tags\n");
-        for (int i = Block.blocksList.length; i < Item.itemsList.length; i++) {
+        for (int i = Blocks.blocksList.length; i < Item.itemsList.length; i++) {
             Item item = Item.itemsList[i];
             String string = itemToCSV(item);
             if (string.isEmpty() && !hideUnused){
@@ -147,8 +147,8 @@ public class DataDumper implements MinecraftAccessor {
                 .append(Registries.BIOMES.getNumericIdOfItem(biome)).append(",")
                 .append(biome.translationKey).append(",")
                 .append(String.format("0x%06X", biome.color)).append(",")
-                .append(Block.blocksList[biome.topBlock].getKey()).append(",")
-                .append(Block.blocksList[biome.fillerBlock].getKey()).append(",")
+                .append(Blocks.blocksList[biome.topBlock].getKey()).append(",")
+                .append(Blocks.blocksList[biome.fillerBlock].getKey()).append(",")
                 .append(biome.hasSurfaceSnow()).append(",");
 
         builder.append("\"");
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
similarity index 99%
rename from src/main/java/net/minecraft/client/Minecraft.java
rename to game/client/src/main/java/net/minecraft/client/Minecraft.java
index ed22306f2..bd05f7846 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -158,7 +158,7 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.helper.ScreenShot;
+import net.minecraft.client.util.helper.ScreenShot;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Time;
 import net.minecraft.core.util.phys.AABB;
diff --git a/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
similarity index 82%
rename from src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
rename to game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
index 530b597ed..09f700a35 100644
--- a/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
@@ -42,23 +42,33 @@ public class ClientSkinVariantList extends SkinVariantList {
 
 	@Override
 	public @NotNull String getSkinReference(@Nullable String variantJsonPath, @NotNull String defaultKey, int skinIndex) {
+		EntityVariants variants = getEntityVariants(variantJsonPath);
+		if (variants == null) return defaultKey;
+		return variants.getKeyFromIndex(skinIndex);
+	}
+
+	protected @Nullable EntityVariants getEntityVariants(@Nullable String variantJsonPath) {
 		try {
-			if (!Minecraft.getMinecraft(this).gameSettings.mobVariants.value) return defaultKey;
-			if (variantJsonPath == null) return defaultKey;
+			if (!Minecraft.getMinecraft(this).gameSettings.mobVariants.value) return null;
+			if (variantJsonPath == null) return null;
 			if (!variantProcessorMap.containsKey(variantJsonPath)) {
 				loadJson(variantJsonPath);
 			}
-			EntityVariants var = variantProcessorMap.get(variantJsonPath);
-			if (var != null) {
-				return var.getKeyFromIndex(skinIndex);
-			}
+			return variantProcessorMap.get(variantJsonPath);
 		} catch (Exception e) {
-      LOGGER.error("Failed to load json at '{}'!", variantJsonPath, e);
+			LOGGER.error("Failed to load json at '{}'!", variantJsonPath, e);
 			variantProcessorMap.put(variantJsonPath, null); // Null the path after an exception happened trying to load it, prevents exception spam
-			e.printStackTrace();
 		}
-		return defaultKey;
+		return null;
 	}
+
+	@Override
+	public int nextSkinVariant(@Nullable String variantJsonPath, int skinIndex) {
+		EntityVariants variants = getEntityVariants(variantJsonPath);
+		if (variants == null) return skinIndex;
+		return variants.getNextVariant(skinIndex);
+	}
+
 	public void loadJson(String variantJsonPath) {
 		load: try (InputStream stream = mc.texturePackList.getResourceAsStream(variantJsonPath)){
 			if (stream == null) return;
@@ -163,6 +173,20 @@ public class ClientSkinVariantList extends SkinVariantList {
 			return String.valueOf(index % skins);
 		}
 
+		public int getNextVariant(int index) {
+			if (variantEntries != null) {
+				VariantEntry currentEntry = variantEntries[index];
+				for (int i = 1; i < variantEntries.length; i++) {
+					if (currentEntry != variantEntries[(index + i)%variantEntries.length]) {
+						return (index + i)%variantEntries.length;
+					}
+				}
+				return index;
+			} else {
+				return (index + 1) % skins;
+			}
+		}
+
 		protected static class VariantEntry {
 			public final String textureKey;
 			public final double weight;
diff --git a/src/main/java/net/minecraft/client/entity/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
similarity index 98%
rename from src/main/java/net/minecraft/client/entity/particle/Particle.java
rename to game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
index 28bbe4f01..4b9a0c36f 100644
--- a/src/main/java/net/minecraft/client/entity/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
@@ -123,9 +123,9 @@ public class Particle extends Entity {
     public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         if (this.tex == null) return;
         float u0 = (float) this.tex.getIconUMin();
-        float u2 = (float) this.tex.getSubIconU(1);
+        float u2 = (float) this.tex.getIconUMax();
         float v0 = (float) this.tex.getIconVMin();
-        float v2 = (float) this.tex.getSubIconV(1);
+        float v2 = (float) this.tex.getIconVMax();
         float r = 0.1F * this.size;
         float x = (float)(this.xo + (this.x - this.xo) * partialTick - xOff);
         float y = (float)(this.yo + (this.y - this.yo) * partialTick - yOff);
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
similarity index 97%
rename from src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
rename to game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index 32d9a47d9..cd2bd043d 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -52,7 +52,7 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
         addDispatch("puffrgb", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticlePuffRGB(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
         addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleRedstoneDust(world, x, y, z, data));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleItemBreaking(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
-        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
+        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleBlockBreaking(world, x, y, z, motionX, motionY, motionZ, Blocks.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
         addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleSnowShovel(world, x, y, z, motionX, motionY, motionX));
         addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new ParticleHeart(world, x, y, z, motionX, motionY, motionX));
         addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ, data) -> {
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
similarity index 89%
rename from src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
rename to game/client/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
index d0c7a43ac..d4ed48f6f 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleFirefly.java
@@ -115,24 +115,25 @@ public class ParticleFirefly extends Particle {
         this.gCol += this.oG;
         this.bCol += this.oB;
 
-        float u0 = (float) tex.getIconUMin();
-        float u2 = (float) tex.getSubIconU(1 / 16f);
-        float v0 = (float) tex.getIconVMin();
-        float v2 = (float) tex.getSubIconV(1 / 16f);
+        float u0 = (float) this.tex.getIconUMin();
+        float u2 = (float) this.tex.getIconUMax();
+        float v0 = (float) this.tex.getIconVMin();
+        float v2 = (float) this.tex.getIconVMax();
         float r = 0.1F * size;
         float x = (float) (xo + (this.x - xo) * partialTick);
         float y = (float) (yo + (this.y - yo) * partialTick);
+        float z = (float) (zo + (this.z - zo) * partialTick);
         float br = 1.0f;
         if (LightmapHelper.isLightmapEnabled()) {
             t.setLightmapCoord(getLightmapCoord(partialTick));
         } else {
             br = getBrightness(partialTick);
         }
-        t.setColorOpaque_F(rCol * br, gCol * br, bCol * br);
-        t.addVertexWithUV(x + r, y - r, 0, u2, v2);
-        t.addVertexWithUV(x + r, y + r, 0, u2, v0);
-        t.addVertexWithUV(x - r, y + r, 0, u0, v0);
-        t.addVertexWithUV(x - r, y - r, 0, u0, v2);
+        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.addVertexWithUV(x + r, y - r, z/10, u2, v2);
+        t.addVertexWithUV(x + r, y + r, z/10, u2, v0);
+        t.addVertexWithUV(x - r, y + r, z/10, u0, v0);
+        t.addVertexWithUV(x - r, y - r, z/10, u0, v2);
     }
 
     @Override
@@ -152,13 +153,16 @@ public class ParticleFirefly extends Particle {
 
         this.xo = this.x;
         this.yo = this.y;
+        this.zo = this.z;
         this.xd = (MathHelper.sin((this.sinTimer) * 0.15f)) / 60f;
         this.yd = (MathHelper.cos((this.sinTimer) * 0.15f)) / 60f;
+        this.zd = (MathHelper.cos(this.sinTimer * 0.15f)) / 60f;
         if (this.isReversed) {
             this.xd = -this.xd;
             this.yd = -this.yd;
+            this.zd = -this.zd;
         }
-        this.move(this.xd, this.yd, 0);
+        this.move(this.xd, this.yd, this.zd);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
similarity index 97%
rename from src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
rename to game/client/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
index 2981c08c6..02499f5af 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/ParticleLeaf.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 public class ParticleLeaf extends Particle {
@@ -27,7 +28,7 @@ public class ParticleLeaf extends Particle {
     }
 
     public ParticleLeaf init(int x, int y, int z) {
-        Block block = Block.blocksList[this.world.getBlockId(x, y, z)];
+        Block block = Blocks.blocksList[this.world.getBlockId(x, y, z)];
         if (!(block instanceof BlockLeavesBase)) this.remove();
         int col = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(world, x, y, z);
         this.rCol *= (float) (col >> 16 & 0xff) / 255F;
diff --git a/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
similarity index 99%
rename from src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
rename to game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 5f8093ad6..40642c06a 100644
--- a/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -27,6 +27,7 @@ import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.client.gui.toasts.AchievementToast;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockPortal;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.block.entity.TileEntityFlag;
@@ -162,7 +163,7 @@ public class PlayerLocal extends Player
                 {
                     timeUntilPortal = 10;
                     mc.sndManager.playSound("portal.travel", SoundCategory.WORLD_SOUNDS, 1.0F, random.nextFloat() * 0.4F + 0.8F);
-                    int targetDim = ((BlockPortal) Block.blocksList[portalID]).targetDimension;
+                    int targetDim = ((BlockPortal) Blocks.blocksList[portalID]).targetDimension;
                     if (dimension == targetDim)
                     {
                         mc.usePortal(0, portalColor);
